                                  APPENDIX B                             THE MEM.SAV FACILITYThis appendix assumes familiarity with Appendix A and is for the ADVANCED USER.It describes how the MEM.SAV facility works, not just how to operate it. Anunderstanding of this appendix should help you:    o  Know when to use this facility and how it will help you.           o  Know when you can avoid using it, to save the time it takes for its disk       operations.           o  Know why it is reading or writing the MEM.SAV file under different       circumstances.SHARING MEMORY BY DUP AND USER PROGRAMSThe DUP-Area can be shared by DUP and user programs in two ways:    1. By restoring DUP from DUP.SYS when going to the DUP Menu from a user       program. In this case, the program's data in the DUP-Area is lost.           2. By swapping the program's data to and from disk (MEM.SAV file), when       going between the TOP-DOS Menu and your program.SWAPPING DUP-AREA MEMORYIf a program uses the DUP-area, and you want to be able to return to yourprogram after going to the TOP-DOS Menu, then the data in the DUP-area must besaved before DUP is read in over it.In this case, the program's data in the DUP-area is written to the MEM.SAV filewhen you go to the TOP-DOS Menu and read back to the DUP-area when you returnto your program.This function is also performed when you load programs into the DUP-area orwrite binary files from it.FACTORS CONTROLLING MEM.SAV ACTIONSThere are several factors that affect the action the MEM.SAV facility willtake. These include:    o  Is the MEM.SAV facility ON?           o  Is the MEM.SAV file data valid?           o  Has a program written data in the DUP-area?           o  Has the data in the MEM.SAV file been loaded into the DUP-area?           o  Is a program about to be written to or from the DUP-area?TOP-DOS                               -60-      Let us look at several cases involving these factors.                     1.  A PROGRAM WRITES IN THE DUP-AREAThe first case to be considered is when a program writes into the DUP-area. TheAtari BASIC cartridge is such a program and will be used as the example forthis case. BASIC uses the DUP-area for storing the user program.    EXCEPTION: If the DOS-Resident option is enabled, the DUP-area is not used    by programs, like BASIC, which correctly use MEMLO to determine where to    begin their storage area. (See the DOS-Resident section of Chapter Six and    also Appendix A.)The action taken in Case-1 depends on several factors, as will be seen below.IF MEM.SAVE FACILITY IS OFFIf MEM.SAV is OFF, when you go to the TOP-DOS Menu from BASIC (by typing"DOS"), your program in the DUP-area is not saved on disk. Consequently, yourBASIC program will be destroyed when the TOP-DOS Menu program (DUP) is restoredto the DUP-area from the DUP.SYS file.If you had SAVE'd your BASIC program before you left BASIC and if you don'tplan to return to your BASIC program from the Menu, then you have no problem:it is OK that the MEM.SAV facility was OFF.However, if you want to find your program intact when you return to BASIC, thenMEM.SAV should be ON.IF MEM.SAV FACILITY IS ONIf MEM.SAV is ON when you go to the TOP-DOS Menu from BASIC, your program inthe DUP-area is saved on disk in the MEM.SAV file, before DUP is restored fromthe DUP.SYS file.IF MEM.SAV HOLDS VALID DATAIn this case, where MEM.SAV was ON and your program in the DUP-area was writtento the MEM.SAV file on disk, TOP-DOS takes note that the MEM.SAV file holdsvalid data (<VALID> is shown in the Status Display).When you return to BASIC from the Menu (by typing "B"), TOP-DOS loads theMEM.SAV file into the DUP-area.Back in BASIC, your program is intact.IF MEM.SAV FILE DATA NOT VALIDSuppose you decide that you don't want your BASIC program restored when goingback to BASIC. Or maybe you are going to load and run another program, so thatthe data in the MEM.SAV file is no longer valid.TOP-DOS                               -61-      In this case, you can notify TOP-DOS to inhibit the reading and writing fo theMEM.SAV file either by turning the MEM.SAV facility OFF:    1>N F<RETURN>or by "clearing" the MEM.SAV facility:    1>N C<RETURN>which leaves the MEM.SAV facility ON, but notes that the MEM.SAV file does nothold valid data (<INVALID> is shown in the Status Display).WHY NOT LEAVE THE MEM.SAVE FACILITY ONBefore continuing to the next case, let's answer the questions: If the MEM.SAVfacility is so great, why not leave it ON all the time?The reason is simple: It takes a long time -- about 30 seconds -- to save andrestore the DUP-area to and from the MEM.SAV disk file.So when you don't need it, you'll want to turn OFF the MEM.SAV facility.If you need the MEM.SAV facility ON, but want to stop it from saving andrestoring invalid data, us the C Clear paramater in the N MEM.SAV command, asdiscussed above. That will stop the wasted operations, but leave the facilityON.                     2.  LOADING A PROGRAM TO THE DUP-AREAThe second case is where you load -- but do not run -- a binary program thatoverlaps the DUP-area.PROGRAM, NOT DATA, IN THE DUP AREANote that this case is different from Case-1.In Case-1, the program did not itself overlap the DUP-area, but rather itstored data (your BASIC program, for example) in the DUP-area, when it ran.In this case, Case-2, the program itself is loaded into the DUP-area (by the Lcommand). This presents a special problem to TOP-DOS, since DUP getsoverwritten in the process!HOW TOP-DOS LOADS TO THE DUP-AREAYou might wonder how, when you are in the TOP-DOS Menu, you can use the L Loadcommand to load a file to the DUP-area, where DUP itself resides?The answer is that the loader is not in the DUP-area, but rather in the DOS(memory-resident) area. All TOP-DOS does for an L command is to get the fileinformation from you and then transfer control to the memory-resident (DOS)part of TOP-DOS to perform the load.TOP-DOS                               -62-      If the binary file you are loading contains data to be loaded in the DUP-area,it will destroy the TOP-DOS Menu program in the process. TOP-DOS takes care ofthis by reloading DUP.SYS into the DUP-area before returning to the TOP-DOSMenu.IF MEM.SAV FILE HOLDS VALID DATAIf the MEM.SAV file holds valid data, then it will be loaded into the DUP-areabefore a binary program which overlaps the DUP-area is loaded.The reason the MEM.SAV file is loaded before the binary file is that theMEM.SAV file may hold data in a different part of the DUP-area than that usedby the binary file. If the MEM.SAV file were not loaded first, the data in theMEM.SAV file would be lost when the DUP-area is later written to the MEM.SAVfile.AFTER THE LOAD, BACK TO THE MENUAfter the binary load is completed, we must get back to the TOP-DOS menu.(Remember, in this case, Case-2, the program is loaded -- but not run. So wehave to go back to the Menu.) To get back to the Menu, DUP must be restored tothe DUP-area from the DUP.SYS file. In the process, the binary program justloaded will be overwritten and destroyed. To avoid the loss of the program datain the DUP-area, it must first be saved in the MEM.SAV file.Thus, the MEM.SAV facility must be ON before loading a binary file into theDUP-area, unless the binary file is to be run at its Run address, as part ofthe L Load process (see Case-3).RE-CAP OF CASE-2Loading -- but not running -- a binary file which overlaps the DUP-arearequires the following steps:    o  The MEM.SAV file is loaded into the DUP-area, if the MEM.SAV file holds       valid data and the MEM.SAV facility is ON.           o  The binary file is loaded.           o  The DUP-area is saved to the MEM.SAV file, if the MEM.SAV facility is       ON.           o  Dup is restored to the DUP-area from the DUP.SYS file.           o  The TOP-DOS Menu program is reentered.               3.  LOADING AND RUNNING A PROGRAM IN THE DUP-AREAThis case is related to Case-2.In Case-2, the program in the DUP-area is NOT run. In this case, Case-3, theprogram IS run, using the Run-Address contained in the binary file.TOP-DOS                               -63-      This difference is important, since in this case, we do not have to return tothe TOP-DOS Menu after the load. Thus, the DUP-area does not have to be savedto the MEM.SAV file and DUP does not have to be restored from the DUP.SYSfile!However, if the MEM.SAV file holds valid data, the DUP-area will still berestored from the MEM.SAV file before the binary file is loaded into theDUP-area.RE-CAP OF CASE-3The following steps are taken in Case-3, where a binary file that overlaps theDUP-area is loaded and run:    o  The DUP-area is restored from the MEM.SAV file, if the MEM.SAV file       holds valid data.           o  The binary file is loaded.        o  The program is run.        NOTE:  Case-3 is simpler than Case-2, because we don not return to the    TOP-DOS Menu after the load, since the program is immediately run. Thus,    the TOP-DOS Menu does not have to be restored or the program in the    DUP-area saved.                       4.  RUNNING A PROGRAM NOT IN THE DUP-AREABefore running a program, even if not in the DUP-area, the MEM.SAV file will beloaded to the DUP-area, if it holds valid data.To understand why this is done, it is important to realize that the DUP-area isconsidered to be part of the user-program memory. When you are using theTOP-DOS Menu commands, DUP (from the DUP.SYS file) is in the DUP-area. TheMEM.SAV file represents the user-program "image" of the DUP-area at this time,if it holds valid data. Therefore, when going to a user program (by the M or Pcommands), this user-program image of the DUP-area is restored from theMEM.SAVE file.                       5.  BINARY SAVE FROM THE DUP-AREAThis case is where the area to be written by a Binary Save "K" command overlapsthe DUP-area.If the MEM.SAV file holds valid data, this file will be loaded to the DUP-area,before the binary file is written.HOW TO TURN ON MEM.SAV WHILE IN BASIC OR ASSEMBLERIf you find yourself in BASIC (or ASSEMBLER) with the MEM.SAV facility OFF, youcan turn it ON by:TOP-DOS                               -64-          POKE 5445,128   [BASIC]    C 1545<80       [ASSEMBLER](Or you can turn the facility OFF by POKE'ing a 0 in the same location.)SIZE OF THE MEM.SAV FILEThe MEM.SAV file is 71 sectors long for the first release version of TOP-DOS.(In TOP-DOS 1.5+, the MEM.SAV file is 108 sectors long.) Room for this filemust exist on the disk in Drive-1, to use the MEM.SAV facility.                                                                               TOP-DOS                               -65-      