                                  APPENDIX C                             HEXADECIMAL NOTATIONThis appendix presents a brief explanation of the hexadecimal notation ("hex",for short). A table is given to aid in the conversion between decimal and hex.The use of the hex number system stems from te extensive use of the 8-bit"byte" as the basic unit of information in computers. To aid in representingits bits, a byte is divided into two 4-bit parts called "nibbles".Each nibble can assume one of 16 values from 0 through 15. Thus a hexadecimal,or 16-based, number system follows as the natural method of representing dataand addresses in computers. Each nibble is represented by one hex digit; abyte, by two hex digits; a two-byte "word" or address, by four hex digits, etc.(Words and addresses in the 6502 are two bytes in size.)In the decimal number system there are ten values to be represented: 0 through9. Conveniently, there are ten numerals, 0 through 9, to represent thesevalues.However, since widespread use of the hexadecimal number system is relativelynew, there are no numeral symbols t represent the six values above 9.Therefore, six symbols had to be chosen to represent these values. The six sochosen are the capital letters A through F. Thus, the 16 hex digits are 0through 9 and A through F (A=10, B=11, C=12, D=13, E=14, F=15).The basic principle of a number system is that each digit in a number carriesthe weight of its position in the number. For example, in the decimal system,the value of the number:          2345can be determined by adding the contribution of each digit. The low-order digit(the right-most one) carries the weight of 1; the next digit, of 10; the next,of 100; the next of 1000; etc. Thus, for this example:          5 x 1    =    5          4 x 10   =   40          3 x 100  =  300          2 x 1000 = 2000                     ----          Total    = 2345In the hex number system, the same principle applies, but the base is 16,rather than 10. If the number in the above example were hex, it would have thevalue:          5 x 1    =    5          4 x 16   =   64          3 x 256  =  768          2 x 4096 = 8192                     ----          Total    = 9029TOP-DOS                               -66-      Thus, 2345 hex = 9029 decimal. Note that each of the weights is 16 times thesize of the previous weight for the 16-based hex system, whreas, for the10-based decimal system, the multiplier of the weights is 10.For another example, the value of the hex number:            ABCDis evaluated:            HEX              DECIMAL          ---------   -----------------          D x 1    =  13 x 1    =    13          C x 16   =  12 x 16   =   192          B x 256  =  11 x 256  =  2816          A x 4096 =  10 x 4096 = 40960                                  -----          Total                 = 43981Thus, ABCD hex = 43981 decimal.The table given below helps in converting between hex and decimal. Up to fourhex digits can be converted, which is all you will need for the ATARIcomputers.To convert from hex to decimal, just add the weighted values from the columnsof the table according to the position of the digits of a hex number.To use the table in the reverse direction requires subtraction. Start with thedecimal number and find the largest number in the table which is not largerthan the number itself. Subtract the table number from the given number. Repeatthe process with the difference until nothing is left.Using the above example, backwards, convert the decimal number:          43981to hex. From the table, the largest number not greater than 43981 is 40960,corresponding to the hex digit "A", in the 4th column. Then:          43981 - 40960 =  3021: A000           3021 -  2816 =   205:  B00            205 -   192 =    13:   C0             13 -    13 =     0:    D                                 ----          Total                  ABCDTOP-DOS                               -67-                HEX-DECIMAL CONVERSION TABLE          ____________________________          HEX          DECIMAL          ___   _____________________                1ST   2ND   3RD   4TH                ___   ___  ____ _____                 0     0     0     0     0                 1     1    16   256  4096                 2     2    32   512  8192                 3     3    48   768 12288                 4     4    64  1024 16384                 5     5    80  1280 20480                 6     6    96  1536 24576                 7     7   112  1792 28672                 8     8   128  2048 32768                 9     9   144  2304 36864                 A    10   160  2560 40960                 B    11   176  2816 45056                 C    12   192  3072 49152                 D    13   208  3328 53248                 E    14   224  3584 57344                 F    15   240  3840 61440                                                                               TOP-DOS                               -68-      