                                  APPENDIX D                           TOPICS FOR ADVANCED USERSThis appendix contains topics of interest to advanced users who may wish totake advantage of some capabilities of TOP-DOS which are available to anassembly-language program. The read of this appendix is assumbed familiar withthe 6502 microprocessor and the ATARI OS.All locations and byte values are given in hex.KEY LOCATIONS    0714 - Device Time-out    0715 - Device error retry count    1544 - Flag: MEM.SAV file holds valid data    1545 - Flag: MEM.SAV facility is ON    154C - Error number of last error    154F - Flag: DOS-Resident option is ON    1550 - Address of first location beyond DUP-Area (2 bytes)    1552 - Flag: Display memory map on binary load    1554 - Left margin    1555 - Flag: Bypass-Cartridge option is ON    155A - Default run address for P command (2 bytes)    2480 - Command line input buffer (80 decimal bytes)    24D0 - Command parameter buffer (40 decimal bytes)    24F8 - Command-line offset-pointer    24F9 - Parameter offset-pointer    2602 - Flag: Error in reading parameter    2680 - Subroutine: Get file name    2683 - Subroutine: Get file name & set IOCB    2686 - Subroutine: Get decimal number    2689 - Subroutine: Get hex number    NOTES:  1. Flags: Set, if negative; Clear, if positive                   2. Offset-pointer: Byte offset in a buffer                   3. All locations contain one byte, unless otherwise noted.                   4. Device Time-out is the time in seconds that TOP-DOS waits for a           device to respond before trying again. The ATARI DOS 2.0 set this           timeout at 15 (0F hex). TOP-DOS has reduced it to 2, to speed           recovery. If you experience timeouts with your drives, you can           increase this parameter.                   5. Device error retry count is the number of times TOP-DOS will retry           an operation before giving up and issuing an error report.           SUBROUTINESThe subroutines mentioned above and described below facilitate the access andinterpretation of the command-line buffer and store their output in theparameter buffer, in the 6502 registers, or in an IOCB.TOP-DOS                               -69-      These subroutines assume that the command line is is in the command-line bufferand that the command-line pointer contains the offset of the next byte in thecommand line to be interpreted. These conditions are in fact established byTOP-DOS.GET FILE NAME SUBROUTINE  IN:   Command-line pointer: Next byte in Command Line buffer        Parameter pointer: Where file name will be stored          OUT:  Command-line pointer: Advanced beyond file name        Parameter pointer: Advanced beyond file name        GET FILE NAME AND SET IOCB SUBROUTINE          IN:   Command-line pointer: Next byte in Command Line buffer        Parameter pointer: Where file name will be stored        X:  IOCB pointer          OUT:  Command-line pointer: Advanced beyond file name        Parameter pointer: Advanced beyond file name        X:  IOCB pointer        IOCB:  Contains address of file name        GET DECIMAL NUMBER SUBROUTINE          IN:   Command-line pointer: Next byte in Command Line buffer          OUT:  A: Decimal number        Y: Terminating character of hex number        C: Set, if null (i.e.: no hex number was given)        Command-line pointer: Advanced beyond hex number        Error Flag: Set if error        GET HEX NUMBER SUBROUTINE          IN:   A: Low byte of hex number        X: High byte of hex number        Y: Terminating character of hex number        C: Set, if null (i.e.: no hex number was given)        Command-line pointer: Advanced beyond hex number        Error Flag: Set if error        NOTES:     1. The file name stored in the parameter buffer is terminated with an EOL        (End Of Line) character.             2. The command-line pointer is advanced by these subroutines to beyond the        terminating character, except if it is an EOL.             3. These subroutines lie below 4800, so the program which calls them        should be located above 4800.TOP-DOS                               -70-              The use of these subroutines is best illustrated with an example. Suppose youhave written a program which reads an input text file and formats it intoparagraphs. The output could be a disk file or the printer. After the programis written and assembled, it would be loaded with the L command:    L FORMAT<RETURN>If used in this way, you would have to program the reading and interpretationof the input and output filespecs and other parameters. However, by using theabove subroutines, you could simplify the programming task, as well as the useof the program. The program would then be called by:    L FORMAT,IN_TEXT.TXT,OUT_TEXT.FMT,10,70<RETURN>where the parameters are given following the filespec of the binary load file.In this example, the parameters are the input filespec, the output filespec,the left margin, and the right margin. Of course, any names could be used forthe input and output files, or the output filespec could be the Printer "P:".Your program would include:    LDX #$10     ;USE IOCB-1 FOR INPUT    JSR $2683    ;GET INPUT FILE NAME AND SET IOCB-1    ;    ;             CODE TO OPEN THE INPUT FILE    ;    LDX #$20     ;USE IOCB-2 FOR OUTPUT    JSR $2683    ;GET OUTPUT FILE NAME AND SET IOCB-2    ;    ;             CODE TO OPEN THE OUTPUT FILE    ;    JSR $2686    ;GET LEFT MARGIN (DECIMAL)    STA LEFT     ;AND STORE IT    JSR $2686    ;GET RIGHT MARGIN    STA RIGHT    ;AND STORE IT    ;    ;After reading the parameters your program is then free to use the area below4800 for storage, since the above subroutines will no longer be needed.                                                                               TOP-DOS                               -71-      