                                  APPENDIX F                          TOP-DOS RAMDISK ENHANCEMENTTOP-DOS SUPPORTS RAMDISKIf your TOP-DOS disk includes the files AXLON and/or MOSAIC, then it can beenhanced to handle a "ramdisk" with either the AXLON 128K RAM or the MOSAIC 64KSELECT RAM for the ATARI 800 computer.In either case, the additional RAM is made to look like a disk drive toTOP-DOS.ADVANTAGE OF RAMDISKThe advantage of having a ramdisk is the greatly increased transfer speed whenreading or writing data.Transfers between the ramdisk and RAM are almost instantaneous.Thus, you can load files from a ramdisk without the usual long delay imposed bya real disk load.Transfers between the ramdisk and a real disk are about twice as fast asbetween two real disks.AUGMENTING TOP-DOS FOR RAMDISKIn order to achieve this capability, TOP-DOS must be augmented with additionalcomputer program code. This code is added to the memory-resident part ofTOP-DOS -- that part contained in the DOS.SYS file. The additional code hasbeen limited to one "page" (256 bytes). (See Appendix A for more information onthe structure of TOP-DOS.)The TOP-DOS contained on your disk is a "standard" TOP-DOS. That is, when youBoot the disk, TOP-DOS comes up without the ramdisk capability. You may usethis TOP-DOS as is, or you may augment it with either of the ramdisks.A SINGLE COMMAND CREATES YOUR RAMDISKThis augmentation of TOP-DOS to implement a ramdisk for either the AXLON orMOSAIC RAM is accomplished by a single TOP-DOS command. Simply load either theAXLON or MOSAIC file:    1>L AXLON<RETURN>          or    1:L MOSAIC<RETURN>This just takes a couple of seconds. TOP-DOS is now augmented with the ramdiskselected: AXLON or MOSAIC. The ramdisk is set to Drive-8, single-density.    AXLON NOTE: Be sure that the switch on the AXLON board is set ON, to permit    the ramdisk operation. If this switch is OFF, the ramdisk will not    function.TOP-DOS                               -75-          CONFIRMING THE RAMDISKGet a Status Display to see the effect of this augmentation process. (See the Scommand.)    1>S J<RETURN>will produce the Status Display. It should now include "8S" in the driveconfiguration, that is, Drive-8, Single-density. It should also include eitherAXLON or MOSAIC to indicate that your TOP-DOS is augmented with that ramdiskcapability.Note that MEMLO has increased by 180 hex: 100 (256 decimal) for the additionalpage of code, plus 80 (128 decimal) for the buffer for your new ramdisk. (For adescription of MEMLO, see Chapter Three and Appendix A. For a presentation ofhex, refer to Appendix C.)SAVING YOUR AUGMENTED TOP-DOSBefore using your new ramdisk, you might want to save the DOS files to anotherdisk to preserve the augmented TOP-DOS. (See the H command for thisoperation.)INITIALIZING YOUR NEW RAMDISKTo use your new ramdisk, first it must be initialized. (See the I command.)Alsways use the V option, since the ramdisk is not formatted like a real disk.(If you attempt to format a ramdisk, by omitting the V option, you will get an"ERR 139" [NAK] message.)    1>I 8V<RETURN>When you omit the second parameter, as shown in the above command, the ramdisksize defaults to the full use of all available RAM. For AXLON, this is largerthan a standard single-density disk. To simulate a standard disk to permit theuse of the J Disk Duplicate command, type "I 8V,90".    NOTE: If you have three MOSAIC 64K SELECT boards installed, you will have    144K of RAM for your ramdisk. But TOP-DOS can only handle 118K for a single    density drive. In this case, the ramdisk will be initialized at its maximum    size (118*8=944 sectors) and you will get the message "Max=118". This    message means that the second parameter of the I command can't exceed 118.    USING YOUR NEW RAMDISKYou are now ready to use your new ramdisk. Try copying some files to it. If oneof these files is a binary load file, try loading it to RAM and see how fast itloads. Get a Directory listing:    1>8<RETURN>to verify the ramdisk contents.TOP-DOS                               -76-      SELECTING YOUR RAMDISK AS THE SYSTEM DRIVEYou may want to select your ramdisk as the System Drive. (See Chapter Four andalso the S command.)The command:    1>S S8<RETURN>selects your ramdisk as the System Drive. If you choose to do this, be sure tocopy the DUP.SYS file to your ramdisk, since TOP-DOS goes to the System Driveto load the DUP.SYS file when you go to DOS from BASIC or another userprogram.USING A "HELLO" FILE TO SETUP YOUR RAMDISKThe HELLO facility of TOP-DOS may be used to initialize and set up your ramdiskon Boot-up. Just create a command file with the desired TOP-DOS commands, andname it HELLO. (See Chapter Six for a description of the HELLO facility and theQ command. in Chapter Five for information on creating a command file.)Your TOP-DOS disk contains a sample HELLO file, named HELLO.RAM. This fileselects your ramdisk as the System Drive and leaves it containing the DUP.SYSfile. The process consists of setting your ramdisk as the System Drive,initializing the ramdisk, writing the DOS files to it, deleting the DOS.SYSfile from it, and finally getting a Directory listing.    NOTE: With TOP-DOS 1.5+, you can write only DUP.SYS to the ramdisk with the    following command:          1>H 8U<RETURN>        It is much faster than copying from a real disk drive. You can also write    only DOS.SYS with the "H 8O" parameter ("U" for dUp, and "O" for dOs). You    must also reply with a "Y" to the prompt following the H command.    To activate this HELLO.RAM file, copy it, as HELLO, to the disk that you wrotethe augmented TOP-DOS to:    1>C D8:HELLO.RAM,D2:HELLO<RETURN>Or, you can execute this file directly, using the Q command:    1>Q D1:HELLO.RAM<RETURN>              or    1>Q HELLO.RAM<RETURN>CREATING YOUR OWN HELLO FILEYou will want to create your own HELLO file. If you don't want your ramdisk tobe your System Drive, you will not need to have the DUP.SYS file on it. But youwill probably want to copy some of your most frequently used programs to it, sothat you can access them quickly.TOP-DOS                               -77-      CUSTOMIZING YOUR NEW RAMDISKYou may modify your new ramdisk to suit your particular needs. This can beaccomplished by including the commands in the HELLO file, or you can make thechanges when you want.The following material is primarily for the ADVANCED USER and assumesfamiliarity with the characteristics of your ramdisk.SETTING THE RAMDISK SIZEYou can initialize your ramdisk to a different size than the default size whichis used when you don't give a second parameter to the I command. For the AXLONramdisk, you may use 90 (720/8) as the second parameter to make the ramdisklook like a standard ATARI drive. This will allow you to use the J DuplicateDisk command with your ramdisk.If you have the MOSAIC SELECT RAM, you must have a total of at least 144K ofRAM to be able to accomplish this same result. That is, you will need at leasttwo 64K SELECT boards to get a ramdisk which is the full size of an ATARIdrive.Ramdisk Size LimitsIf you give the second parameter of the I command, it must be at least 46 toaccomodate the VTOC and File Directory. Furthermore, you must be careful not tospecify a parameter which makes the ramdisk appear to be larger than the memorywhich is available to the ramdisk.For the AXLON ramdisk, the available RAM is 128K, minus 16K which is needed forthe program memory. Thus, 112K of RAM is available fo the AXLON ramdisk. Thistranslates to a maximum value of 112 for the second parameter of the Icommand.For the MOSAIC ramdisk, determine the total RAM in your system. Then subtract48K for program RAM to get the RAM available for the ramdisk. Use this figureas the maximum for the second paramater of the I command.    NOTE: The second parameter of the I command is the same as the number of    "K" of RAM available for your ramdisk. This coincidence is a result of the    fact that there are eight sectors per "K" for single-density drives, and    the second parameter of the I command is the number of sectors divided by    eight.    CHANGING THE DENSITY OF THE RAMDISKIf you have enough RAM, you can change the density of your ramdisk todouble-density if you wish. Just use the S command.The sector size for double-density drives is 256 bytes, which is twice the sizefor single-density drives. Therefore, you must have twice as much RAM to meetthe minimum necessary to contain the VTOC and File Directory. This minimum forTOP-DOS                               -78-      double-density is 96K. The AXLON has 112K available for the ramdisk, unluss youchoose to use some of its banks for other purposes (see below).For the MOSAIC, you need at least 48K for program memory, so the minimum is96+48=144K of total system RAM for double density.REMOVING THE RAMDISK FROM THE DRIVE LISTIf you wish, you can remove the ramdisk from the drive list, using the Rparameter of the S command (X paramater in ver. 1.5). This will eliminate theneed for a drive buffer for the ramdisk and thus reduce MEMLO when you are notusing your ramdisk.CHANGING THE DRIVE NUMBERIf you wish, you can change the drive number of your ramdisk. The drive numberis stored at 1518 (hex). You can set it to any number from one to eight. Usethe R command.CHANGING THE BANKSYou can change the banks used for the ramdisk. There are three bytes whichcontrol the bank selection:    1A80 - Standard bank number for program memory    1A81 - First bank number for ramdisk    1A82 - Next bank number for ramdiskThe addresses are in hex.Standard Bank NumberThe "standard" bank number is that which is used for program memory. For theAXLON ramdisk, it is the bank used for memory at 4000-7FFF. For the MOSAIC, itis the bank at C000-CFFF.The default for AXLON is bank #0. For the MOSAIC, the default is "no-bank",which is represented by the value FF.For the MOSAIC, if you change the standard bank number from FF to a real value,you will extend the RAM available to program from 48K to 52K. However, thisputs Screen RAM in a MOSAIC bank. The result will be a flashing and tearing ofthe Screen display during any ramdisk activity. No harm results from thiseffect, but it could be annoying. Therefore, this configuration for the MOSAICis not recommended.First and Next Bank NumbersThe first and next bank numbers control the range of banks used for yourramdisk. By the "next" bank number is meant the last bank number, plus one.The default values for these bank numbers were selected to make use of allavailable RAM for your ramdisk. For the AXLON, the values are (1,8). For theTOP-DOS                               -79-      MOSAIC, they are (0,n), where "n" is the total number of banks available forramdisk use.You may wish to use some of te banks for purposes other than for your ramdisk.Default Bank Numbers      Bank            Address  AXLON  MOSAIC      Standard Bank    1A80      0      FF      First Bank       1A81      1      0      Next Bank        1A82      8      nWhere "n" is the number of banks available for ramdisk use.Obviously, care must be used in changing any of these values. If you do changethem, you should save the DOS files (H command) and re-boot -- or at leastpress SYSTEM-RESET.Good Luck!                                                                               TOP-DOS                               -80-      